#include <stdio.h>
#include <stdlib.h>


struct node {
	int value;
	struct node *next;
};

struct node *alloc_node (int value) 
{
	struct node *new_node = malloc(sizeof(struct node));	
	if (!new_node) {
		printf("malloc() failed\n");
		exit(1);
	}

	new_node->value = value;
	new_node->next = NULL;

	return new_node;
}


struct node *insert_after (struct node **head_ptr, struct node *node, int value)
{
	struct node *new_node = alloc_node(value);

	if (node == NULL) { /* inserisci in testa */
		new_node->next = *head_ptr;
		*head_ptr = new_node;
	} else {
		new_node->next = node->next;
		node->next = new_node;
	}

	return new_node;
}

void delete_greater_than (struct node **head_ptr, int soglia)
{
	struct node *n = *head_ptr;		
	struct node **prev_ptr = head_ptr;

	while (n != NULL) {
		if (n->value > soglia) {
			/* Must be deleted */
			*prev_ptr = n->next;	
			struct node *deleted = n;
			n = n->next;
			free(deleted);
		} else {
			prev_ptr = &(n->next);
			n = n-> next;
		}
	}
}

void print_list (struct node *head)
{
	struct node *n = head;
	while (n != NULL) {
		printf("%d\n", n->value);
		n = n->next;
	}
}


int main()
{
	struct node *head = NULL;

	struct node *n5 = insert_after(&head, NULL, 5);
	insert_after(&head, NULL, 7);
	insert_after(&head, n5, 0);

	print_list(head);
	delete_greater_than(&head, 3);
	print_list(head);

	return 0;
}
