#include <stdio.h>
#include <stdlib.h>

#include "lista_studenti.h"
#include "lista_voti.h"


struct nodo_studente *alloca_nodo_studente (unsigned int matricola) 
{
	struct nodo_studente *nuovo = malloc(sizeof(struct nodo_studente));	
	if (!nuovo) {
		printf("malloc() failed\n");
		exit(1);
	}

	nuovo->matricola = matricola;
	nuovo->head_voti = NULL;
	nuovo->next = NULL;

	return nuovo;
}


struct nodo_studente *inserisci_studente (struct nodo_studente **head_ptr,
		 unsigned int matricola)
{
	struct nodo_studente *nuovo = alloca_nodo_studente(matricola);

	nuovo->next = *head_ptr;
	*head_ptr = nuovo;

	return nuovo;
}

double calcola_media (struct nodo_studente *s)
{
	int somma = 0;
	int count = 0;
	
	struct nodo_voto *n = s->head_voti;
	while (n != NULL) {
		somma += n->voto;
		++count;
		n = n->next;
	}

	return (double)somma/count;
}


void stampa_studenti (struct nodo_studente *head)
{
	struct nodo_studente *n = head;
	while (n != NULL) {
		printf("%7u: media %f - ", n->matricola, calcola_media(n));
		stampa_voti(n->head_voti);
		n = n->next;
	}
}


